void makePoster(String path){    
  //Read all files in the set path into an arraylist
  ArrayList<File> allFiles = listFilesRecursive(path);
  int imgCount = 0;
  for (int i = 0; i < allFiles.size(); i++){
    File f = allFiles.get(i);
    for (int j = 0; j < imgExt.length; j++) {   
     if ((f.getName()).indexOf(imgExt[j]) != -1){
       imgCount++;
     }
    }
  } 
  if (imgCount > maxImages){
    background(BG);
     textFont(regularFont, 16);
     text("I'm confused! Try me again with less images!", 20, height/5, width, 100); 
     textAlign(CENTER);
       endRecord();
  } else {

  //Empty the MediaArray before we start populating again
   MediaArray.clear(); 

  int tx = 0;
  int ix = 0;
  //Set up timestamp
  int s = second(); 
  int m = minute();
  int h = hour();
  String second = nf(s, 2);
    String minute = nf(m, 2);
      String hour = nf(h, 2);
        String timestamp = hour + ":" + minute + ":" + second;


  //Cycle through all the files in the directory
  for (int i = 0; i < allFiles.size(); i++) {
    File f = allFiles.get(i);
    MimeUtil.registerMimeDetector("eu.medsea.mimeutil.detector.ExtensionMimeDetector");
    Collection<MimeType> coll = MimeUtil.getMimeTypes(f);
    for(MimeType type : coll){ 
        typeString = type.toString();       
    }
    MimeUtil.unregisterMimeDetector("eu.medsea.mimeutil.detector.ExtensionMimeDetector"); 
    String [] elements = new String[7];
          elements[0] = f.getName();
          elements[1] = Long.toString(f.length());
          String lastModified = new Date(f.lastModified()).toString();
          elements[2] = lastModified;
          elements[3] = f.getAbsolutePath();
          elements[4] = timestamp;
          elements[5] = "MAPPED: CONFIRM"; 
          elements[6] = "/Volume/path/"; //To be done still!
      //Check to see if there is any file that matches the mime types we want. 
        if(typeString.contains("image")){
        //Code to create a media class ready for output
           String imgpath = f.getAbsolutePath();
           imgRecord[ix] = new ImageMedia(elements,imgpath);            
           MediaArray.add(imgRecord[ix]);
           ix++;
        } else if(typeString.contains("text")){
          String[] textlines = loadStrings(f.getAbsolutePath());
          txtRecord[tx] = new TextMedia(elements, textlines);
          MediaArray.add(txtRecord[tx]);
          tx++;
        } else {
        if ((f.getName()).indexOf(".pde") != -1){
          pdelines = loadStrings(f.getAbsolutePath());
          println(pdelines);  
          
        }   
   }
  }
     
  //Debug
  fill(255);
  background(BG);
  //Begin drawing!
   int rA = int(random(MediaArray.size()));
     Media singleMedia = (Media) MediaArray.get(rA);
     sketch = new Sketches(int(singleMedia.timeOfDay()));
     sketch.setup();
     sketch.draw();
 int z = 0;
  for (y = 20; y <=479; y +=postAmount()) {
    for (x = 60; x <= 486; x +=postAmount()) {
      for (z = 0; z < MediaArray.size(); z++) {
        Media multipleMedia = (Media) MediaArray.get(z);
        multipleMedia.drawMetaMultiple(20,20+(15*z),metaFont,11,(int(singleMedia.timeOfDay())-20),500,800); 
        int r = int(random(10));
        if (r == 0 || r == 1) {
          if (multipleMedia instanceof ImageMedia){
            ImageMedia thisImg = (ImageMedia) MediaArray.get(z);
            thisImg.drawMedia(x,y);
          }
      } else if( r == 2 || r == 3) {
        int r2 = int(random(4));
        if (r2 == 0) {
          fill(0);
        if (multipleMedia instanceof TextMedia){
            TextMedia thisTxt = (TextMedia) MediaArray.get(z);
            thisTxt.drawMedia(bigFont,350,x-100,y,width,height);
          }
        } else {
          if (multipleMedia instanceof TextMedia){
            TextMedia thisTxt = (TextMedia) MediaArray.get(z);
            thisTxt.drawMedia(midFont,45,300,y,width,height);
          }
        }
      } else if( r == 4) {
        if (multipleMedia instanceof ImageMedia){
          ImageMedia fillcolour = (ImageMedia) MediaArray.get(z);
          fillcolour.averageColour(fillcolour.imagefile);
          rect(x,y,x+y,y+x);
        }
      } else if (r == 5 || r == 6){
        if (multipleMedia instanceof TextMedia){
          TextMedia thisTxt = (TextMedia) MediaArray.get(z);
          thisTxt.drawMedia(metaFont,11,300,y,200,height);
        }
      }
    }
  }
  }
  if(MediaArray.size() > 0) {
     singleMedia.drawMetaSingle(20,5,metaFont,11,255,500,800);
  }
  
  saveFrame(USB + "/your-usb-poster.png");
  saveFrame(sketchPath + "/your-usb-poster.png");
  saveFrame(sketchPath + "/usb-posters-####.tga");
  
  String printFile = sketchPath + "/your-usb-poster.png";
  String[] printCMD = { "open", "-a", pathToPrinter + PrinterAppName + ".app", printFile };
  executeCMD(printCMD); 
  
}
}

public int postAmount(){
  int a = MediaArray.size();
  int arraySize = int(map(a, 0, maxImages, 550, 50));
  return arraySize;
}

